# -*- Mode: Python; tab-width: 4 -*-
#
#	$Gaaros: Id$
#	Author: Pavlos Christoforou <pavlos@gaaros.com>
#
# ======================================================================
#
#
#  Disclaimer
#
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#     Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#     Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
#     The name of the author or GAAROS may not be used to endorse or
#     promote products derived from this software without specific prior
#     written permission
#
#
#   THIS SOFTWARE IS PROVIDED BY GAAROS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GAAROS OR HIS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
#
########################################################################

__version__='$Revision: 1.1 $'[11:-2]


import string,marshal
import os

##load font metrics

standard_metrics_path=os.path.join(
    os.path.dirname(__file__),'standard_metrics.msh')

f=open(standard_metrics_path,'rb')
font_metrics=marshal.load(f)
f.close()


def stringwidth(text, font):
    """stringwidth(text, font)

    from Andy Robinson's pdfgen"""

    if font not in font_metrics.keys():
        font='Courier'
    widths = font_metrics[font]
    w = 0
    for char in text:
        w = w + widths[ord(char)]
    return w

def dict_to_pdfdict(dict):
    out=['<<']
    for k,v in dict.items():
        out.append('%s %s'%(k,v))
    out.append('>>')
    return string.join(out,'\n')


class Counter:
    'Simple counter class'
    def __init__(self,start=0):
        self.counts=start
    def incr(self):
        self.counts=self.counts+1
        return self.counts
    def decr(self):
        self.counts=self.counts-1
        return self.counts
    def reset(self):
        self.counts=0
    def __repr__(self):
        return repr(self.counts)
    def __str__(self):
        return str(self.counts)

class CrazyStack:
    def __init__(self,l=None):
        self.elements=l or []
        
    def push(self,elements):
        if type(elements)==type([]):
            self.elements=elements+self.elements
        else:
            self.elements.insert(0,elements)

    def pop(self):
        first=self.elements[0] ## crazy
        del self.elements[0]
        return first

    def __len__(self):
        return len(self.elements)

